package com.zheng.demo;

import java.time.LocalDateTime;
import java.time.Period;
import java.time.ZoneId;
import java.time.ZonedDateTime;
import java.time.format.DateTimeFormatter;
import org.junit.Test;

public class DateTest {

    @Test
    public void test_LocalDateTime_to_formattedString() {
        LocalDateTime now = LocalDateTime.now();
        System.out.println("LocalDateTime now() in ISO_LOCAL_DATE_TIME: "
                + DateTimeFormatter.ISO_LOCAL_DATE_TIME.format(now));
        System.out.println("LocalDateTime now() in ISO_LOCAL_DATE: "
                + DateTimeFormatter.ISO_LOCAL_DATE.format(now));

    }

    @Test
    public void test_ZonedDateTime() {
        ZonedDateTime chicagoTime = ZonedDateTime.now(ZoneId.of("America/Chicago"));

        ZonedDateTime chongqingTime = ZonedDateTime.now(ZoneId.of("Asia/Chongqing"));

        System.out.println("America/Chicago is at: "
                + DateTimeFormatter.ISO_ZONED_DATE_TIME.format(chicagoTime));

        System.out.println("Asia/Chongqing is at: "
                + DateTimeFormatter.ISO_ZONED_DATE_TIME.format(chongqingTime));

        System.out.println("America/Chicago offset:" + chicagoTime.getOffset());
        System.out.println("Asia/Chongqing offset:" + chongqingTime.getOffset());

    }

    @Test
    public void test_formattedString_to_LocalDateTime() {
        DateTimeFormatter formatter = DateTimeFormatter.ofPattern("yyyy-MM-dd HH:mm");
        LocalDateTime d = LocalDateTime.parse("2021-04-05 12:15", formatter);

        System.out.println("Date: " + DateTimeFormatter.ISO_LOCAL_DATE_TIME.format(d));
    }

    @Test
    public void test_add_days_to_LocalDateTime() {
        LocalDateTime newDate = LocalDateTime.now().plus(Period.ofDays(3));
        System.out.println(
                "Three days later: " + DateTimeFormatter.ISO_LOCAL_DATE_TIME.format(newDate));
    }
}
